.\"	$NetBSD: mincore.2,v 1.18 2003/08/07 16:44:01 agc Exp $
.\"
.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)mincore.2	8.1 (Berkeley) 6/9/93
.\"
.Dd June 6, 1999
.Dt MINCORE 2
.Os
.Sh NAME
.Nm mincore
.Nd determine residency of memory pages
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/mman.h
.Ft int
.Fn mincore "void *addr" "size_t len" "char *vec"
.Sh DESCRIPTION
The
.Fn mincore
system call
allows a process to obtain information about whether pages are
core resident.
The status of the memory range is returned in the character-per-page array
.Ar vec .
If the page is resident, the least significant bit of the corresponding
character in
.Ar vec
will be set.
Other bits are reserved for additional information
which future implementations may return.
.Pp
Note that the status of each page may change between the call to
.Fn mincore
and the return of the page status information.
In order to guarantee
that pages will remain in core, the address range must be locked with
.Xr mlock 2 .
.Sh RETURN VALUES
.Fn mincore
returns 0 on success, or \-1 on failure and sets the variable
.Va errno
to indicate the error.
.Sh ERRORS
The
.Fn mincore
call will fail if:
.Bl -tag -width Er
.It Bq Er EFAULT
.Ar vec
points to an illegal address.
.It Bq Er EINVAL
.Ar addr
is not a multiple of the system page size.
.It Bq Er EINVAL
.Ar len
is equal to 0.
.It Bq Er ENOMEM
The address range specified is invalid for the calling process,
or one or more of the pages specified in the range are not mapped.
.El
.Sh SEE ALSO
.Xr madvise 2 ,
.Xr mlock 2 ,
.Xr mprotect 2 ,
.Xr msync 2 ,
.Xr munmap 2 ,
.Xr sysconf 3
.Sh HISTORY
The
.Fn mincore
function first appeared in
.Bx 4.4 .
